unit uRyuLib;

interface

Uses
  IBExternals, IBHeader, IBIntf;

Function  SaveLog(FileName,Msg:PChar):Integer; cdecl;
Function  GetTick:Integer; cdecl;

Function  LeftStr(sz:Pchar; var Len:Integer; szRes:PChar):PChar; cdecl;
Function  SendData(ClassName,Msg:PChar):Integer; cdecl;
Function  IntToDateStr(var Date:Integer):PChar; cdecl;
Function  NowDate:Integer; cdecl;
Function  NowTime:Integer; cdecl;
Function  IncMonth(var Date,Count:Integer):Integer; cdecl;
Function  DecMonth(var Date,Count:Integer):Integer; cdecl;
Function  IncDay(var Date,Count:Integer):Integer; cdecl;
Function  DecDay(var Date,Count:Integer):Integer; cdecl;
Function  WeekOfyear(var Date:Integer):Integer; cdecl;
Function  DayOfTwo(var DateStart,DateEnd:Integer):Integer; cdecl;

Exports
  SaveLog, GetTick, LeftStr, SendData, IntToDateStr, NowDate, NowTime, IncMonth,
  DecMonth, IncDay, DecDay, WeekOfyear, DayOfTwo;

implementation

Uses
  Windows, Messages, SysUtils, IB_Util, Cal, Disk;

{
  declare external function SaveLog
  CString(1024), CString(1024)
  returns
  integer by value
  entry_point 'SaveLog'
  module_name 'RyuLib';
}
Function  SaveLog(FileName,Msg:PChar):Integer;
Begin
  Result:= 0;
  Try
    SaveLogMessage(StrPas(FileName), StrPas(Msg));
  Except
    Result:= -1;
  End;
End;

{ ͺ̽ ν 
  declare external function GetTick
  returns
  integer by value
  entry_point 'GetTick' module_name 'RyuLib'
}
Function  GetTick:Integer; cdecl;
Begin
  Result:= Round(GetTickCount);
End;

{ ͺ̽ ν 
  declare external function LeftStr
  cstring(255), integer, cstring(255)
  returns parameter 3
  entry_point 'LeftStr' module_name 'RyuLib'
}
Function LeftStr(sz:Pchar; var Len:Integer; szRes:PChar):PChar;
Var
  i : Integer;
Begin
  { First, make Result point to same memory as szRes }
  Result:= szRes;

  { Initialize counter }
  i:= 0;
  While (sz^ <> #0) and (i < Len) do Begin
    { Copy one character }
    szRes^:= sz^;
    { Increment pointers to next character }
    Inc(i);
    Inc(sz);
    Inc(szRes);
  End;

  { Terminate result string }
  szRes^:= #0;
End;

{
  declare external function SendData
  CString(1024), CString(1024)
  returns
  integer by value
  entry_point 'SendData'
  module_name 'RyuLib';
}
Function  SendData(ClassName,Msg:PChar):Integer;
Var
  Data : COPYDATASTRUCT;
Begin
  Result:= FindWindow(ClassName, Nil);

  If Result > 0 then Begin
    Try
      Data.cbData:= Length(Msg)+1;
      Data.lpData:= Msg;
      SendMessage(Result, WM_COPYDATA, Result, Integer(@Data));
    Except
    End;
  End;
End;

{ ͺ̽ ν 
  declare external function IntToDateStr
  integer
  returns cstring(10) free_it
  entry_point 'IntToDateStr' module_name 'RyuLib'
}
Function  IntToDateStr(var Date:Integer):PChar;
Var
  stTemp : String;
Begin
  stTemp:= IntToStr(Date);
  stTemp:= Format('%s-%s-%s'#0, [Copy(stTemp, 1, 4), Copy(stTemp, 5, 2), Copy(stTemp, 7, 2)]);
  Result:= IB_Util_Malloc(Length(stTemp));
  Move(stTemp[1], Result^, Length(stTemp));
End;

{ ͺ̽ ν 
  declare external function NowDate
  returns
  integer by value
  entry_point 'NowDate' module_name 'RyuLib'
}
Function  NowDate:Integer;
Begin
  Result:= StrToIntDef(FormatDateTime('yyyymmdd', Now), 0);
End;

{ ͺ̽ ν 
  declare external function NowTime
  returns
  integer by value
  entry_point 'NowTime' module_name 'RyuLib'
}
Function  NowTime:Integer;
Begin
  Result:= StrToIntDef(FormatDateTime('hhnnss', Now), 0);
End;

{ ͺ̽ ν 
  declare external function IncMonth
  integer, integer
  returns
  integer by value
  entry_point 'IncMonth' module_name 'RyuLib'
}
Function  IncMonth(var Date,Count:Integer):Integer;
Var
  DateRec : TDate;
Begin
  DateRec:= IntToDateRec(Date);
  Cal.IncMonth(DateRec, Count);
  Result:= Cal.DateRecToInt(DateRec);
End;

{ ͺ̽ ν 
  declare external function DecMonth
  integer, integer
  returns
  integer by value
  entry_point 'DecMonth' module_name 'RyuLib'
}
Function  DecMonth(var Date,Count:Integer):Integer;
Var
  DateRec : TDate;
Begin
  DateRec:= IntToDateRec(Date);
  Cal.DecMonth(DateRec, Count);
  Result:= Cal.DateRecToInt(DateRec);
End;

{ ͺ̽ ν 
  declare external function IncDay
  integer, integer
  returns
  integer by value
  entry_point 'IncDay' module_name 'RyuLib'
}
Function  IncDay(var Date,Count:Integer):Integer;
Var
  DateRec : TDate;
Begin
  DateRec:= IntToDateRec(Date);
  Cal.IncDay(DateRec, Count);
  Result:= Cal.DateRecToInt(DateRec);
End;

{ ͺ̽ ν 
  declare external function DecDay
  integer, integer
  returns
  integer by value
  entry_point 'DecDay' module_name 'RyuLib'
}
Function  DecDay(var Date,Count:Integer):Integer;
Var
  DateRec : TDate;
Begin
  DateRec:= IntToDateRec(Date);
  Cal.DecDay(DateRec, Count);
  Result:= Cal.DateRecToInt(DateRec);
End;

{ ͺ̽ ν 
  declare external function WeekOfyear
  integer
  returns
  integer by value
  entry_point 'WeekOfyear' module_name 'RyuLib'
}
Function  WeekOfyear(var Date:Integer):Integer;
Var
  iDays, iWeek : Integer;
  DateStart, DateNow : TDate;
Begin
  DateNow:= IntToDateRec(Date);
  DateStart:= DateNow;
  DateStart.Month:= 1;
  DateStart.Day:=   1;

  iDays:= Cal.DayOfTwo(DateStart, DateNow);
  iWeek:= Integer(WeekOftheDay(DateStart));

  Result:= (iDays+iWeek) div 7 + 1;
End;

{ ͺ̽ ν 
  declare external function DayOfTwo
  integer, integer
  returns
  integer by value
  entry_point 'DayOfTwo' module_name 'RyuLib'
}
Function  DayOfTwo(var DateStart,DateEnd:Integer):Integer;
Var
  Date_Start, Date_End : TDate;
Begin
  Date_Start:= IntToDateRec(DateStart);
  Date_End:=   IntToDateRec(DateEnd);

  Result:= Cal.DayOfTwo(Date_Start, Date_End);
End;

initialization
  IsMultiThread:= TRUE;
  CheckIBLoaded;
end.

  declare external function LeftStr
  cstring(255), integer, cstring(255)
  returns parameter 3
  entry_point 'LeftStr' module_name 'RyuLib';

  declare external function SendData
  CString(1024), CString(1024)
  returns
  integer by value
  entry_point 'SendData'
  module_name 'RyuLib';

  declare external function IntToDateStr
  integer
  returns cstring(10) free_it
  entry_point 'IntToDateStr' module_name 'RyuLib';

  declare external function NowDate
  returns
  integer by value
  entry_point 'NowDate' module_name 'RyuLib';

  declare external function NowTime
  returns
  integer by value
  entry_point 'NowTime' module_name 'RyuLib';

  declare external function IncMonth
  integer, integer
  returns
  integer by value
  entry_point 'IncMonth' module_name 'RyuLib';

  declare external function DecMonth
  integer, integer
  returns
  integer by value
  entry_point 'DecMonth' module_name 'RyuLib';

  declare external function IncDay
  integer, integer
  returns
  integer by value
  entry_point 'IncDay' module_name 'RyuLib';

  declare external function DecDay
  integer, integer
  returns
  integer by value
  entry_point 'DecDay' module_name 'RyuLib';

  declare external function WeekOfyear
  integer
  returns
  integer by value
  entry_point 'WeekOfyear' module_name 'RyuLib';

  declare external function DayOfTwo
  integer, integer
  returns
  integer by value
  entry_point 'DayOfTwo' module_name 'RyuLib';  
